/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2024 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const V=require("react"),e=require("prop-types"),g=require("@progress/kendo-date-math"),P=require("@progress/kendo-react-buttons"),M=require("@progress/kendo-svg-icons"),f=require("@progress/kendo-react-intl"),n=require("@progress/kendo-react-common"),_=require("@progress/kendo-react-labels"),L=require("@progress/kendo-dateinputs-common"),w=require("./utils.js"),N=require("../package-metadata.js"),v=require("../utils.js"),o=require("../messages/index.js"),A=require("../timepicker/utils.js"),F=require("../common/ClearButton.js"),R=require("./dateInputIntl.js");function j(c){const t=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(c){for(const i in c)if(i!=="default"){const s=Object.getOwnPropertyDescriptor(c,i);Object.defineProperty(t,i,s.get?s:{enumerable:!0,get:()=>c[i]})}}return t.default=c,Object.freeze(t)}const d=j(V),B="Please enter a valid value!",a=class a extends d.Component{constructor(t){super(t),this.kendoDate=null,this.kendoDateObject=null,this.mounted=!1,this._element=null,this._wrapper=null,this._nativeEvent=null,this.focus=()=>{this._element&&this._element.focus()},this.setValidity=()=>{this.element&&this.element.setCustomValidity&&this.element.setCustomValidity(this.validity.valid?"":this.props.validationMessage||a.defaultProps.validationMessage)},this.updateOnPaste=i=>{!this.element||!this.kendoDate||this.triggerChange(i)},this.spinnersMouseDown=i=>{i.preventDefault();const s=n.getActiveElement(document);this.element&&s!==this.element&&this.element.focus({preventScroll:!0})},this.handleClick=i=>{this.props.onChange&&this.props.onChange(i)},this.nativeWheel=i=>{n.getActiveElement(document)===this.element&&i.preventDefault()},this.increasePart=i=>{var s;(s=this.kendoDate)==null||s.modifyDateSegmentValue(1),this.onChange(i)},this.decreasePart=i=>{var s;(s=this.kendoDate)==null||s.modifyDateSegmentValue(-1),this.onChange(i)},this.elementOnFocus=i=>{this.wrapper&&this.wrapper.classList.add("k-focus"),this.setState({focused:!0})},this.elementOnBlur=i=>{this.wrapper&&this.wrapper.classList.remove("k-focus"),this.setState({focused:!1})},n.validatePackage(N.packageMetadata),this.state={focused:!1}}get _inputId(){return this.props.id+"-accessibility-id"}isFormatChanged(t,i){return typeof t!=typeof i?!0:typeof t=="string"&&typeof i=="string"?t!==i:typeof t=="object"&&typeof i=="object"?JSON.stringify(t)!==JSON.stringify(i):!1}mapFormatToCommonFormat(t){return typeof t=="string"?t:{inputFormat:t,displayFormat:t}}get value(){return this.valueDuringOnChange!==void 0?this.valueDuringOnChange:this.kendoDate&&this.kendoDate.value}get name(){return this.props.name}get min(){return this.props.min!==void 0?this.props.min:a.defaultProps.min}get max(){return this.props.max!==void 0?this.props.max:a.defaultProps.max}get isInSegmentSelection(){const{year:t,month:i,day:s,hours:l,minutes:u,seconds:r}=this.kendoDateObject;return(!t||!i||!s||!l||!u||!r)&&(t||i||s||l||u||r)}get text(){const{placeholder:t}=this.props,i=this.kendoDate&&this.kendoDate.currentText||"";return t!=null&&!this.state.focused&&!this.value?t:i}get validity(){const t=w.isInRange(this.value,this.min,this.max)&&A.isInTimeRange(this.value,this.props.minTime,this.props.maxTime),i=this.props.validationMessage!==void 0,s=(!this.required||this.value!==null)&&t,l=this.props.valid!==void 0?this.props.valid:s;return{customError:i,rangeOverflow:this.value&&this.max.getTime()<this.value.getTime()||!1,rangeUnderflow:this.value&&this.value.getTime()<this.min.getTime()||!1,valid:l,valueMissing:this.value===null}}get element(){return this._element}get validityStyles(){return this.props.validityStyles!==void 0?this.props.validityStyles:a.defaultProps.validityStyles}get required(){return this.props.required!==void 0?this.props.required:!1}get wrapper(){return this._wrapper}get options(){const{format:t,steps:i,placeholder:s,value:l,autoFill:u,enableMouseWheel:r,autoCorrectParts:h,autoSwitchParts:b,autoSwitchKeys:y,twoDigitYearMax:m,allowCaretMode:D,formatPlaceholder:C}=this.props;return{format:t,steps:i,formatPlaceholder:C,placeholder:s,selectPreviousSegmentOnBackspace:!0,value:l||this.value,intlService:this.intlCommon,autoFill:u!==void 0?u:!1,enableMouseWheel:r,autoCorrectParts:h,autoSwitchParts:b,autoSwitchKeys:y||[],twoDigitYearMax:m,allowCaretMode:D}}componentDidMount(){this.setValidity(),this.mounted||(this.wrapper&&this.wrapper.addEventListener("wheel",this.nativeWheel,{passive:!1}),this.kendoDate=this.initKendoDate(),this.kendoDateObject=this.kendoDate.dateObject,this.mounted=!0)}componentDidUpdate(t){this.setValidity(),this.kendoDate&&((this.isFormatChanged(t.format,this.props.format)||t.readonly!==this.props.readonly||t.steps!==this.props.steps||this.intlCommon.locale!==this.kendoDate.options.intlService.locale)&&this.kendoDate.setOptions(this.options,!0),t.value!==this.props.value&&(this.kendoDateObject.getValue()!==null||this.isInSegmentSelection&&this.props.value!==null)&&(this.kendoDateObject.setValue(this.props.value),this.kendoDate.writeValue(this.props.value)),this.props.ariaExpanded!==void 0&&this.props.ariaExpanded&&(this.kendoDate.options.placeholder=null),this.props.ariaExpanded!==void 0&&!this.props.ariaExpanded&&(this.kendoDate.options.placeholder=this.props.placeholder),this.kendoDate.refreshElementValue())}componentWillUnmount(){this.wrapper&&this.wrapper.removeEventListener("wheel",this.nativeWheel)}render(){var x;const{size:t=a.defaultProps.size,fillMode:i=a.defaultProps.fillMode,rounded:s=a.defaultProps.rounded,autoFocus:l=a.defaultProps.autoFocus,unstyled:u}=this.props,r=u&&u.uDateInput;this.props._ref&&(this.props._ref.current=this);const h=f.provideLocalizationService(this),b={...a.defaultProps,...this.props},{name:y,label:m,id:D,disabled:C}=b,I=this.text,E=D||this._inputId,O=!this.validityStyles||this.validity.valid,S=d.createElement("span",{ref:k=>{this._wrapper=k},style:m?void 0:{width:this.props.width},dir:this.props.dir,className:n.classNames(n.uDateInput.wrapper({c:r,size:t,fillMode:i,rounded:s,disabled:C,required:this.required,invalid:!O}),this.props.className)},d.createElement("input",{role:this.props.ariaRole||"textbox",readOnly:this.props.readonly,tabIndex:this.props.tabIndex||0,disabled:this.props.disabled,title:this.props.title!==void 0?this.props.title:I,value:I,type:"text",spellCheck:!1,autoComplete:"off",autoCorrect:"off",autoFocus:l,className:n.classNames(n.uDateInput.inputInner({c:r})),id:E,"aria-label":this.props.ariaLabel,"aria-labelledby":this.props.ariaLabelledBy,"aria-describedby":this.props.ariaDescribedBy,"aria-haspopup":this.props.ariaHasPopup,"aria-disabled":this.props.disabled,"aria-expanded":this.props.ariaExpanded,"aria-controls":this.props.ariaControls,"aria-required":this.props.required,"aria-invalid":!O,onKeyDown:this.onChange.bind(this),onChange:this.onChange.bind(this),onWheel:this.onChange.bind(this),onInput:this.onChange.bind(this),onClick:this.onChange.bind(this),name:y,ref:k=>this._element=k}),this.props.children,this.props.clearButton&&this.props.value&&d.createElement(F,{onClick:this.handleClick,key:"clearbutton"}),this.props.spinners&&d.createElement("span",{className:n.classNames(n.uDateInput.inputSpinner({c:r})),onMouseDown:this.spinnersMouseDown},d.createElement(P.Button,{tabIndex:-1,type:"button",rounded:null,className:n.classNames(n.uDateInput.spinnerIncrease({c:r})),icon:"caret-alt-up",svgIcon:M.caretAltUpIcon,"aria-label":h.toLanguageString(o.increaseValue,o.messages[o.increaseValue]),title:h.toLanguageString(o.increaseValue,o.messages[o.increaseValue]),onClick:this.increasePart}),d.createElement(P.Button,{tabIndex:-1,type:"button",rounded:null,className:n.classNames(n.uDateInput.spinnerDecrease({c:r})),icon:"caret-alt-down",svgIcon:M.caretAltDownIcon,"aria-label":h.toLanguageString(o.decreaseValue,o.messages[o.decreaseValue]),title:h.toLanguageString(o.decreaseValue,o.messages[o.decreaseValue]),onClick:this.decreasePart})));return m?d.createElement(_.FloatingLabel,{label:m,editorId:E,editorValue:(x=this._element)==null?void 0:x.value,editorValid:O,editorDisabled:this.props.disabled,children:S,style:{width:this.props.width}}):S}intl(){return f.provideIntlService(this)}get intlCommon(){return new R.DateInputIntl(f.provideIntlService(this))}triggerChange(t){this.valueDuringOnChange=this.value,this.forceUpdate(),this._nativeEvent=t,this.valueDuringOnChange=void 0}onChange(t){this._nativeEvent&&this.props.onChange&&!g.isEqual(this._nativeEvent.oldValue,this.value)&&this.props.onChange.call(void 0,{syntheticEvent:t,nativeEvent:this._nativeEvent.event,value:this._nativeEvent.value,target:this}),this._nativeEvent=null}initKendoDate(){return new L.DateInput(this._element,{...this.options,format:this.mapFormatToCommonFormat(this.options.format),events:{focus:this.elementOnFocus.bind(this),blur:this.elementOnBlur.bind(this),valueChange:this.triggerChange.bind(this),click:this.handleClick.bind(this)}})}};a.displayName="DateInput",a.propTypes={value:e.instanceOf(Date),format:e.oneOfType([e.string,e.shape({skeleton:e.string,pattern:e.string,date:e.oneOf(["short","medium","long","full"]),time:e.oneOf(["short","medium","long","full"]),datetime:e.oneOf(["short","medium","long","full"]),era:e.oneOf(["narrow","short","long"]),year:e.oneOf(["numeric","2-digit"]),month:e.oneOf(["numeric","2-digit","narrow","short","long"]),day:e.oneOf(["numeric","2-digit"]),weekday:e.oneOf(["narrow","short","long"]),hour:e.oneOf(["numeric","2-digit"]),hour12:e.bool,minute:e.oneOf(["numeric","2-digit"]),second:e.oneOf(["numeric","2-digit"]),timeZoneName:e.oneOf(["short","long"])})]),formatPlaceholder:e.oneOfType([e.oneOf(["wide","narrow","short","formatPattern"]),e.shape({year:e.string,month:e.string,day:e.string,hour:e.string,minute:e.string,second:e.string})]),width:e.oneOfType([e.string,e.number]),tabIndex:e.number,title:e.string,steps:e.shape({year:e.number,month:e.number,day:e.number,hour:e.number,minute:e.number,second:e.number}),min:e.instanceOf(Date),max:e.instanceOf(Date),disabled:e.bool,spinners:e.bool,name:e.string,dir:e.string,label:e.string,id:e.string,ariaLabelledBy:e.string,ariaDescribedBy:e.string,ariaLabel:e.string,ariaRole:e.string,ariaHasPopup:e.oneOfType([e.bool,e.string]),ariaExpanded:e.oneOfType([e.bool]),onChange:e.func,validationMessage:e.string,required:e.bool,validate:e.bool,valid:e.bool,size:e.oneOf([null,"small","medium","large"]),rounded:e.oneOf([null,"small","medium","large","full"]),fillMode:e.oneOf([null,"solid","flat","outline"]),autoFocus:e.bool},a.defaultProps={format:w.DEFAULT_FORMAT,size:"medium",rounded:"medium",fillMode:"solid",formatPlaceholder:w.DEFAULT_FORMAT_PLACEHOLDER,spinners:!1,disabled:!1,max:g.cloneDate(v.MAX_DATE),min:g.cloneDate(v.MIN_DATE),minTime:g.cloneDate(v.MIN_TIME),maxTime:g.cloneDate(v.MAX_TIME),validityStyles:!0,validationMessage:B,placeholder:null,enableMouseWheel:!0,autoCorrectParts:!0,autoSwitchParts:!0,allowCaretMode:!1,twoDigitYearMax:68,ariaHasPopup:"grid",autoFocus:!1};let p=a;const T=n.createPropsContext(),q=n.withIdHOC(n.withPropsContext(T,n.withUnstyledHOC(p)));q.displayName="KendoReactDateInput";f.registerForIntl(p);f.registerForLocalization(p);exports.DateInput=q;exports.DateInputPropsContext=T;exports.DateInputWithoutContext=p;
